
import { EApiCryptoMode } from "../../tsgf/apiCrypto/Models";
import { BaseRequest, BaseResponse, BaseConf } from "./base";


export interface ReqRecoverPlayerRoom extends BaseRequest {
    playerId: string;
    playerToken: string;
    /**可更新玩家显示名*/
    updateShowName?: string;
}

export interface ResRecoverPlayerRoom extends BaseResponse {
    /**全局唯一的玩家ID*/
    playerId: string;
    /**玩家认证令牌*/
    playerToken: string;
    /**当前所在的房间ID*/
    currRoomId?: string;
}

export const conf: BaseConf = {
    cryptoMode: EApiCryptoMode.None,
};